//-----------------------------------------------------------------------
//	File:		$RCSfile: Lab2Testbench.v,v $
//	Version:	$Revision: 1.2 $
//	Desc:		Lab2 Testbench
//	Author:		Greg Gibeling
//	Copyright:	Copyright 2003 UC Berkeley
//	This copyright header must appear in all derivative works.
//-----------------------------------------------------------------------

//-----------------------------------------------------------------------
//	Section:	Change Log
//-----------------------------------------------------------------------
//	$Log: Lab2Testbench.v,v $
//	Revision 1.2  2004/07/08 18:39:51  Administrator
//	Added minor comments
//	
//	Revision 1.1  2004/07/07 23:23:34  Administrator
//	Initial Import
//	Fully Tested
//	Solution works
//	
//-----------------------------------------------------------------------

//-----------------------------------------------------------------------
//	Section:	Defines and Constants
//-----------------------------------------------------------------------
`timescale		1 ns/1 ps		// Display things in ns, compute them in ps
`define HalfCycle	18.518			// This is in ns (see above)
`define Cycle		(`HalfCycle * 2)	// Didn't you learn to multiply?
//-----------------------------------------------------------------------

//-----------------------------------------------------------------------
//	Module:		Lab2Testbench
//	CUT:		Lab2Top
//-----------------------------------------------------------------------
module Lab2Testbench;
	//---------------------------------------------------------------
	//	Wires and Regs
	//---------------------------------------------------------------
	reg			Clock, Reset;

	reg	[7:0]		In;
	wire	[7:0]		Out;

	reg			Enable, PeakSelect;
	//---------------------------------------------------------------

	//---------------------------------------------------------------
	//	CUT:	Lab2Top
	//---------------------------------------------------------------
	Lab2Top		CUT(	.In(			In),
				.Out(			Out),
				.Enable(		Enable),
				.PeakSelect(		PeakSelect),
				.Clock(			Clock),
				.Reset(			Reset));
	//---------------------------------------------------------------


	//---------------------------------------------------------------
	//	Clock Source
	//		This section will generate a clock signal,
	//		turning it on and off according the HalfCycle
	//		time, in this case it will generate a 27MHz clock
	//		THIS COULD NEVER BE SYNTHESIZED
	//---------------------------------------------------------------
	initial Clock =			1'b0;	// We need to start at 1'b0, otherwise clock will always be 1'bx
	always #(`HalfCycle) Clock =	~Clock;	// Every half clock cycle, invert the clock
	//---------------------------------------------------------------

	//---------------------------------------------------------------
	//	Test Stimulus
	//		This initial block will periodically set new
	//		values for the inputs to the CUT.
	//		THIS COULD NEVER BE SYNTHESIZED
	//---------------------------------------------------------------
	initial begin
		Reset =			1'b0;
		In =			8'h00;
		Enable =		1'b0;
		PeakSelect =		1'b0;
		#(`Cycle);
		Reset =			1'b1;
		#(`Cycle);
		Reset =			1'b0;

		// Feel free to modify anything past this point!
		// You can add or remove test cases as you feel nessecary

		In =			8'h01;
		Enable =		1'b1;
		#(`Cycle);
		In =			8'h02;
		Enable =		1'b0;
		#(`Cycle);
		In =			8'hA0;
		Enable =		1'b1;
		#(`Cycle);
		In =			8'h18;
		#(`Cycle);
		Enable  =		1'b0;
		#(`Cycle * 4);
		PeakSelect =		1'b1;
		#(`Cycle * 4);
		PeakSelect =		1'b0;

		// Add more test cases here!!
	end
	//---------------------------------------------------------------
endmodule
//-----------------------------------------------------------------------